@Library('enterprise-pipeline-library@master') _

properties([
        [$class: 'BuildDiscarderProperty', strategy: [$class: 'LogRotator', artifactDaysToKeepStr: '', artifactNumToKeepStr: '', daysToKeepStr: '90', numToKeepStr: '20']
        ]]);


podTemplates(label: agent, containers: [
        containerTemplate(name: 'java', image: 'artifactory.us.bank-dns.com:5000/edse/jenkins-java-agent:latest', ttyEnabled: true, command: 'cat'),
        containerTemplate(name: 'docker', image: 'artifactory.us.bank-dns.com:5000/edse/jenkins-docker-agent:latest', ttyEnabled: true, command: 'cat'),
        containerTemplate(name: 'kubectl', image: 'artifactory.us.bank-dns.com:5000/edse/jenkins-kubectl-agent:latest', ttyEnabled: true, command: 'cat')
],
        volumes: [hostPathVolume(hostPath: '/var/run/docker.sock', mountPath: '/var/run/docker.sock')],
        imagePullSecrets: ['usb-artifactory-prod1']
)

        {

            try {
                stage("Checkout Code") {
                    node(agent) {
                        deleteDir()
                        echo "Checking out Test Automation source code from GitLab repo"
                        checkoutRepo {}
                        stash name: 'sources', useDefaultExcludes: false

                        if (!automation_browser) {
                            automation_browser = "CHROME"
                        }

                        if (!automation_testEnvironment) {
                            automation_testEnvironment = "UAT1"
                        }

                        if (!automation_runMode) {
                            automation_runMode = "LOCAL"
                        }
                    }
                }

                stage('Maven Build') {
                    node(slave) {
                        unstash 'sources'
                        dir('""-automation-framework') {
                            echo "Peforming Maven Build"
                            mvnBuild {
                                windowsBuild = true
                                javaVersion = 8
                                settingsFileId = '""-settings'
                                defaultMavenSettings = "-s settings.xml"
                                mavenGoals = 'clean test'
                                cucumberTestReportsEnabled = true
                                junitTestReportsEnabled = true
                                proxyEnabled = false
                                mavenOpts = ["-Xmx2048m"]
                                mavenArgs = ["-P" + automation_testProfile, buildnumberoption, automation_testEnvironmentOption, automation_runModeOption, automation_browserOption, automation_isJenkinsJob]
                            }
                            checkpoint 'mvn build'
                        }
                    }
                }
            } catch (Exception ex) {
                node(agent) {
                    def emailSubject = "Jenkins Job failed"
                    def emailBody = "See the job details in Cloudbees Jenkins:  ${BUILD_URL}."
                    notify {
                        //emailId = 'DRSystemsTeam@usbank.com'
                        emailId = 'nimesh.patel@usbank.com'
                        subject = emailSubject
                        body = emailBody
                    }
                }
                throw ex
            }

        }
